// content/services/auction_worklet/public/mojom/trusted_signals_cache.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_TRUSTED_SIGNALS_CACHE_MOJOM_H_
#define CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_TRUSTED_SIGNALS_CACHE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "content/services/auction_worklet/public/mojom/trusted_signals_cache.mojom-features.h"  // IWYU pragma: export
#include "content/services/auction_worklet/public/mojom/trusted_signals_cache.mojom-shared.h"  // IWYU pragma: export
#include "content/services/auction_worklet/public/mojom/trusted_signals_cache.mojom-forward.h"  // IWYU pragma: export
#include "mojo/public/mojom/base/big_buffer.mojom.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "content/common/content_export.h"




namespace auction_worklet::mojom {

class TrustedSignalsCacheClientProxy;

template <typename ImplRefTraits>
class TrustedSignalsCacheClientStub;

class TrustedSignalsCacheClientRequestValidator;


class CONTENT_EXPORT TrustedSignalsCacheClient
    : public TrustedSignalsCacheClientInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = TrustedSignalsCacheClientInterfaceBase;
  using Proxy_ = TrustedSignalsCacheClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = TrustedSignalsCacheClientStub<ImplRefTraits>;

  using RequestValidator_ = TrustedSignalsCacheClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSuccessMinVersion = 0,
    kOnErrorMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnSuccess_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnError_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~TrustedSignalsCacheClient() = default;

  
  virtual void OnSuccess(TrustedSignalsCompressionScheme compression_scheme, ::mojo_base::BigBuffer compression_group_data) = 0;

  
  virtual void OnError(const std::string& error_message) = 0;
};

class TrustedSignalsCacheProxy;

template <typename ImplRefTraits>
class TrustedSignalsCacheStub;

class TrustedSignalsCacheRequestValidator;


class CONTENT_EXPORT TrustedSignalsCache
    : public TrustedSignalsCacheInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = TrustedSignalsCacheInterfaceBase;
  using Proxy_ = TrustedSignalsCacheProxy;

  template <typename ImplRefTraits>
  using Stub_ = TrustedSignalsCacheStub<ImplRefTraits>;

  using RequestValidator_ = TrustedSignalsCacheRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kGetTrustedSignalsMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GetTrustedSignals_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~TrustedSignalsCache() = default;

  
  virtual void GetTrustedSignals(const ::base::UnguessableToken& compression_group_token, ::mojo::PendingRemote<TrustedSignalsCacheClient> client) = 0;
};



class CONTENT_EXPORT TrustedSignalsCacheClientProxy
    : public TrustedSignalsCacheClient {
 public:
  using InterfaceType = TrustedSignalsCacheClient;

  explicit TrustedSignalsCacheClientProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnSuccess(TrustedSignalsCompressionScheme compression_scheme, ::mojo_base::BigBuffer compression_group_data) final;
  
  void OnError(const std::string& error_message) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class CONTENT_EXPORT TrustedSignalsCacheProxy
    : public TrustedSignalsCache {
 public:
  using InterfaceType = TrustedSignalsCache;

  explicit TrustedSignalsCacheProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetTrustedSignals(const ::base::UnguessableToken& compression_group_token, ::mojo::PendingRemote<TrustedSignalsCacheClient> client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT TrustedSignalsCacheClientStubDispatch {
 public:
  static bool Accept(TrustedSignalsCacheClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TrustedSignalsCacheClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TrustedSignalsCacheClient>>
class TrustedSignalsCacheClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TrustedSignalsCacheClientStub() = default;
  ~TrustedSignalsCacheClientStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TrustedSignalsCacheClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TrustedSignalsCacheClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT TrustedSignalsCacheStubDispatch {
 public:
  static bool Accept(TrustedSignalsCache* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      TrustedSignalsCache* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<TrustedSignalsCache>>
class TrustedSignalsCacheStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  TrustedSignalsCacheStub() = default;
  ~TrustedSignalsCacheStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TrustedSignalsCacheStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return TrustedSignalsCacheStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT TrustedSignalsCacheClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT TrustedSignalsCacheRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // auction_worklet::mojom

namespace mojo {

}  // namespace mojo

#endif  // CONTENT_SERVICES_AUCTION_WORKLET_PUBLIC_MOJOM_TRUSTED_SIGNALS_CACHE_MOJOM_H_