// third_party/blink/public/mojom/ai/ai_writer.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_WRITER_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_WRITER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/ai/ai_writer.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/ai_writer.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/ai_writer.mojom-forward.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/ai/model_streaming_responder.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {

class AIWriterProxy;

template <typename ImplRefTraits>
class AIWriterStub;

class AIWriterRequestValidator;


class BLINK_COMMON_EXPORT AIWriter
    : public AIWriterInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AIWriterInterfaceBase;
  using Proxy_ = AIWriterProxy;

  template <typename ImplRefTraits>
  using Stub_ = AIWriterStub<ImplRefTraits>;

  using RequestValidator_ = AIWriterRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kWriteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Write_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~AIWriter() = default;

  
  virtual void Write(const std::string& input, const std::optional<std::string>& context, ::mojo::PendingRemote<::blink::mojom::ModelStreamingResponder> pending_responder) = 0;
};



class BLINK_COMMON_EXPORT AIWriterProxy
    : public AIWriter {
 public:
  using InterfaceType = AIWriter;

  explicit AIWriterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Write(const std::string& input, const std::optional<std::string>& context, ::mojo::PendingRemote<::blink::mojom::ModelStreamingResponder> pending_responder) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AIWriterStubDispatch {
 public:
  static bool Accept(AIWriter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AIWriter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AIWriter>>
class AIWriterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AIWriterStub() = default;
  ~AIWriterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AIWriterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AIWriterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AIWriterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT AIWriterCreateOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AIWriterCreateOptions, T>::value>;
  using DataView = AIWriterCreateOptionsDataView;
  using Data_ = internal::AIWriterCreateOptions_Data;

  template <typename... Args>
  static AIWriterCreateOptionsPtr New(Args&&... args) {
    return AIWriterCreateOptionsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AIWriterCreateOptionsPtr From(const U& u) {
    return mojo::TypeConverter<AIWriterCreateOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AIWriterCreateOptions>::Convert(*this);
  }


  AIWriterCreateOptions();

  explicit AIWriterCreateOptions(
      const std::optional<std::string>& shared_context);


  ~AIWriterCreateOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AIWriterCreateOptionsPtr>
  AIWriterCreateOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AIWriterCreateOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AIWriterCreateOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AIWriterCreateOptions_UnserializedMessageContext<
            UserType, AIWriterCreateOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AIWriterCreateOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return AIWriterCreateOptions::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AIWriterCreateOptions_UnserializedMessageContext<
            UserType, AIWriterCreateOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AIWriterCreateOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::string> shared_context;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AIWriterCreateOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
AIWriterCreateOptionsPtr AIWriterCreateOptions::Clone() const {
  return New(
      mojo::Clone(shared_context)
  );
}

template <typename T, AIWriterCreateOptions::EnableIfSame<T>*>
bool AIWriterCreateOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->shared_context, other_struct.shared_context))
    return false;
  return true;
}

template <typename T, AIWriterCreateOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.shared_context < rhs.shared_context)
    return true;
  if (rhs.shared_context < lhs.shared_context)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AIWriterCreateOptions::DataView,
                                         ::blink::mojom::AIWriterCreateOptionsPtr> {
  static bool IsNull(const ::blink::mojom::AIWriterCreateOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AIWriterCreateOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::AIWriterCreateOptions::shared_context)& shared_context(
      const ::blink::mojom::AIWriterCreateOptionsPtr& input) {
    return input->shared_context;
  }

  static bool Read(::blink::mojom::AIWriterCreateOptions::DataView input, ::blink::mojom::AIWriterCreateOptionsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_AI_AI_WRITER_MOJOM_H_