// third_party/blink/public/mojom/partitioned_popins/partitioned_popin_params.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PARTITIONED_POPINS_PARTITIONED_POPIN_PARAMS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PARTITIONED_POPINS_PARTITIONED_POPIN_PARAMS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/partitioned_popins/partitioned_popin_params.mojom-features.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/partitioned_popins/partitioned_popin_params.mojom-shared.h"  // IWYU pragma: export
#include "third_party/blink/public/mojom/partitioned_popins/partitioned_popin_params.mojom-forward.h"  // IWYU pragma: export
#include "services/network/public/mojom/site_for_cookies.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/common_export.h"




namespace blink::mojom {








class BLINK_COMMON_EXPORT PartitionedPopinParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PartitionedPopinParams, T>::value>;
  using DataView = PartitionedPopinParamsDataView;
  using Data_ = internal::PartitionedPopinParams_Data;

  template <typename... Args>
  static PartitionedPopinParamsPtr New(Args&&... args) {
    return PartitionedPopinParamsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PartitionedPopinParamsPtr From(const U& u) {
    return mojo::TypeConverter<PartitionedPopinParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PartitionedPopinParams>::Convert(*this);
  }


  PartitionedPopinParams();

  PartitionedPopinParams(
      const ::url::Origin& opener_top_frame_origin,
      const ::net::SiteForCookies& opener_site_for_cookies);


  ~PartitionedPopinParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PartitionedPopinParamsPtr>
  PartitionedPopinParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PartitionedPopinParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PartitionedPopinParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PartitionedPopinParams_UnserializedMessageContext<
            UserType, PartitionedPopinParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<PartitionedPopinParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return PartitionedPopinParams::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PartitionedPopinParams_UnserializedMessageContext<
            UserType, PartitionedPopinParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PartitionedPopinParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::url::Origin opener_top_frame_origin;
  
  ::net::SiteForCookies opener_site_for_cookies;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PartitionedPopinParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PartitionedPopinParamsPtr PartitionedPopinParams::Clone() const {
  return New(
      mojo::Clone(opener_top_frame_origin),
      mojo::Clone(opener_site_for_cookies)
  );
}

template <typename T, PartitionedPopinParams::EnableIfSame<T>*>
bool PartitionedPopinParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->opener_top_frame_origin, other_struct.opener_top_frame_origin))
    return false;
  if (!mojo::Equals(this->opener_site_for_cookies, other_struct.opener_site_for_cookies))
    return false;
  return true;
}

template <typename T, PartitionedPopinParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.opener_top_frame_origin < rhs.opener_top_frame_origin)
    return true;
  if (rhs.opener_top_frame_origin < lhs.opener_top_frame_origin)
    return false;
  if (lhs.opener_site_for_cookies < rhs.opener_site_for_cookies)
    return true;
  if (rhs.opener_site_for_cookies < lhs.opener_site_for_cookies)
    return false;
  return false;
}


}  // blink::mojom

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::PartitionedPopinParams::DataView,
                                         ::blink::mojom::PartitionedPopinParamsPtr> {
  static bool IsNull(const ::blink::mojom::PartitionedPopinParamsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::PartitionedPopinParamsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::PartitionedPopinParams::opener_top_frame_origin)& opener_top_frame_origin(
      const ::blink::mojom::PartitionedPopinParamsPtr& input) {
    return input->opener_top_frame_origin;
  }

  static const decltype(::blink::mojom::PartitionedPopinParams::opener_site_for_cookies)& opener_site_for_cookies(
      const ::blink::mojom::PartitionedPopinParamsPtr& input) {
    return input->opener_site_for_cookies;
  }

  static bool Read(::blink::mojom::PartitionedPopinParams::DataView input, ::blink::mojom::PartitionedPopinParamsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PARTITIONED_POPINS_PARTITIONED_POPIN_PARAMS_MOJOM_H_